//This is an abstract class of a generic object to draw.

#ifndef __DIRCOLUMN_H__
#define __DIRCOLUMN_H__

#include <FL/gl.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <string>
#include "FileWindow.h"
#include "dir.h"

#define WINDOW_ZSPACING 5.0
#define MAX_WINDOWS_VISIBLE 30

class DirColumn {
 public:
  ////////////////
  //Constructor //
  ////////////////
  DirColumn();
  DirColumn(string dir, float w, float h, float x, float y, float z);

  //////////////
  //Mutators: //
  //////////////
  //move the object's center point in space
  void x(float);
  void y(float);
  void z(float);

  //change the size of the object
  void setWidth(float);
  void setHeight(float);

  //this shuffles through the separate directory windows.
  //they wrap to the back once they hit the front (designated 
  //by this class' z member).  
  //the parameter is how much to move in the z direction.
  void shuffle(float);

  //////////////
  //Getters:  //
  //////////////
  //get the object's center point in space
  float x(void);
  float y(void);
  float z(void);
  
  //get the size of the object
  float getWidth(void);
  float getHeight(void);

  //////////////
  // Events:  //
  //////////////
  //returns empty if not clicked or if action was already taken.
  //otherwise returns the directory chosen. 
  string onClick(int button, vector<void*> pickStacks, uint depth);

  //////////////
  // The Rest://
  //////////////
  void draw(void);

 protected:

 private:
  //the center point
  float centerx, centery, centerz;

  //the size
  float width, height;

  //the directory this column represents
  string directory;

  //this is the column of filewindows
  vector<FileWindow*> col;

  //this is the file window at the front
  FileWindow* current;

};


#endif
