//This is an icon. It reperesents a directory or a file.

#ifndef __ICON_H__
#define __ICON_H__

#include <FL/gl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "textureLoader.h"

//defines the ratio of the icon's size to its text
#define ICONHEIGHT 0.8

#define ICONWIDTH 0.77

//space between glyph and text
#define TEXTMARGIN 0.01

//these are for drawing the icons
#define BORDERTHICKNESS 0.01
#define NUMOFTEXTLINES 5
#define FILELINESMARGIN 0.1

#define SMALLESTDIRDIVISION 5.0
#define MAXFILES 20.0

using namespace std;

class Icon {
 public:
  ////////////////
  //Constructor //
  ////////////////
  Icon();
	
  Icon(string dir, float w, float h, float x, float y, float z);

  //////////////
  //Mutators: //
  //////////////
  //move the object's center point in space
  void x(float);
  void y(float);
  void z(float);

  //change the size of the object
  void setWidth(float);
  void setHeight(float);

  //////////////
  //Getters:  //
  //////////////
  //get the object's center point in space
  float x(void);
  float y(void);
  float z(void);
  
  //get the size of the object
  float getWidth(void);
  float getHeight(void);

  string getFullPath(void);

  //////////////
  // Events:  //
  //////////////
  string onClick(int button, int x, int y);

  //////////////
  // The Rest://
  //////////////
  void draw(void);

 protected:

 private:
  //the center point
  float centerx, centery, centerz;

  //the size
  float width, height;

  //these are the sizes of the top and bottom of a directory
  float top;     //files are top
  float bottom; //directories are bottom

  //path contains the whole path of the file, whereas name contains
  //the name of the file minus all the path info
  string path;
  string name;

  //this tells if it is a directory or just a file
  bool isADir;

  //these are the colors of the icon
  float dircolor[4];
  float dirtopcolor[4];
  static float filecolor[4];
  static float filebordercolor[4];
  static float filetextcolor[4];
  static float textcolor[4];

  static GLuint iconTexture;
};


#endif
