//These functions return a vector containing each directory entry.
//It either returns the subdirectories, or the files in that directory,
//depending on the which parameter (definitions below).

#include <vector>
#include <string>

#define GETFILES 0
#define GETDIRS  1

using namespace std;

vector<string> getDirList(string directory, int which);

//makes sure there is a trailing slash on each directory.
//returns a normalized directory.
string normalizeDir(string);

//strips off the rightmost directory in the path and returns it.
//if called on root, does nothing.
string getParentDir(string dir);

//strips the path from file and returns simply the filename
string getBaseName(string dir);

//returns true if file is a directory
bool isDir(string file);
