//this function draws text on the screen at the coordinates given.
//it wraps at the width provided, moving down height for each line.
//x, y, z is the point at the top-left corner.
//if height is 0, the text will not wrap and will be truncated.
//color is a 4 element vector.

#include "writeText.h"
#include <GL/glut.h>

//for now font is ignored and the font is a bitmapped font
void writeText(string text, void* font, float* color, 
	       float x, float y, float z, float width, float height) {
  const float charWidth = height * FONTWIDTHRATIO;
  float currentWidth = 0.0;
#ifndef NO_STROKE_FONTS
  void* FONT = GLUT_STROKE_ROMAN;
#endif


  //font = GLUT_STROKE_MONO_ROMAN;
  //must figure out the height of the font so we can translate 
  //user's coords to bottom-left coords.
  //if (height == 0.0)
  // height = 1.0;
  
  y -= height;
  
  glPushMatrix();
  
  glTranslatef(x, y, z);

  /* //draw a test height line
  glColor3f(1.0,0.0,0.0);
  glBegin(GL_LINES);
    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(0.0, height, 0.0);

    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(height * FONTWIDTHRATIO, 0.0, 0.0);
  glEnd();
  */

  glColor4fv(color);
  glLineWidth(1.5);

#ifdef NO_STROKE_FONTS
  glRasterPos2f(x, y);
#endif

  glScalef(height * SCALE_FACTOR, height * SCALE_FACTOR, height * SCALE_FACTOR);
  for (uint i = 0; i < text.length(); i++) {
    currentWidth += charWidth;

    //we SHOULD reset to next line if we go past the allowed end,
    //but instead we'll just print an ellipsis
    if (currentWidth + charWidth >= width) {
#ifndef NO_STROKE_FONTS
      glutStrokeCharacter(FONT, '.');
      glutStrokeCharacter(FONT, '.');
      glutStrokeCharacter(FONT, '.');
#endif
      break;
      //y -= height;
#ifdef NO_STROKE_FONTS
      glRasterPos2f(x, y);
#endif
    }

#ifdef NO_STROKE_FONTS
    glutBitmapCharacter(GLUT_BITMAP_8_BY_13, text[i]);
#else
    glutStrokeCharacter(FONT, text[i]);
#endif
   
  }
  
  glPopMatrix();
}
